;|								;;
	D B A R O v.1.1 (Dynamic Block & Attribute Rotation)	;;
	By Andrea Andreetti Copyright  2010-09-20		;;
								;;
	v.1.0							;;
	Allow to rotate Block in dynamic mode and put		;;
	all attrubute on angle 0 and allow osnaps settings	;;
								;;
	v.1.1							;;
	New feature:						;;
	1) specify Angle of rotation or Dynamic input		;;
	2) Orthomode function added on dynamic mode		;;
	3) USC orientation detectionon Dynamic Mode.		;;
								|;

(vl-load-com)


;|					|;
					;;
(defun getcursnaps (/ cur_mode mode$)
  (setq mode$ nil)
  (if (< (setq cur_mode (getvar "osmode")) 15360)
    (mapcar '(lambda (x)
               (if (not (zerop (logand cur_mode (car x))))
                 (setq mode$ (append mode$ (list (cadr x))))
               )
             )
            '((0 "_non")
              (1 "_end")
              (2 "_mid")
              (4 "_cen")
              (8 "_nod")
              (16 "_qua")
              (32 "_int")
              (64 "_ins")
              (128 "_per")
              (256 "_tan")
              (512 "_nea")
              (1024 "_qui")
              (2048 "_app")
              (4096 "_ext")
              (8192 "_par")
             )
    )
  )
  mode$
)
					;;
;|					|;







;|					|;
					;;
(defun getsnappoint (#point / point2x)
  (if point1
    (setvar "LASTPOINT" point1)
  )
  (redraw)
  ;;check for SNAPS
  (setq point2x nil)
  (if (setq osnaps_list (vl-remove "_app" (getcursnaps)))
    (progn (setq osnaps_full nil)
           (foreach n osnaps_list
             (if (setq snappoint (osnap #point n))
               (progn
                 (setq osnaps_full (append osnaps_full
                                           (list (cons (distance #point snappoint) (list n snappoint)))
                                   )
                 )
               )
             )
           )
           (if osnaps_full
             (progn (setq sortdist (vl-sort (mapcar 'car osnaps_full) '<))
                    (setq snappy (assoc (car sortdist) osnaps_full))
                    (if (and (> (length osnaps_full) 1) (eq "_nea" (cadr snappy)))
                      (progn (setq snappy2 (assoc (cadr sortdist) osnaps_full))
                             (if (> (/ (car snappy2) 5.0) (car snappy))
                               (showsnaps (setq point2x (caddr snappy)) (cadr snappy))
                               (showsnaps (setq point2x (caddr snappy2)) (cadr snappy2))
                             )
                      )
                      (showsnaps (setq point2x (caddr snappy)) (cadr snappy))
                    )
             )
           )
    )
  )
  (if (and point2x
           (> (/ (getvar "VIEWSIZE") 70.0) (distance #point point2x))
      )
    (setq #point point2x)
  )
  (setq pickpoint #point)
  #point
)
					;;
;|					|;








;|					|;
					;;
(defun showsnaps (coord snap / ncolor viewsize pmg phg pbg pmh phd pmd pbd pmb pmhx pmbx pmgx pmdx pchx pcbx)
  (setq ncolor (atoi (getenv "AutoSnapColor"))) ;(getenv "AutoSnapSize")
  (setq viewsize (/ (getvar "VIEWSIZE") 70.0))
  (setq coord (trans coord 0 1))
  (setq pmg (polar coord (* pi (/ 180 180.0)) (/ viewsize 2.0)))
  (setq phg (polar pmg (* pi (/ 90 180.0)) (/ viewsize 2.0)))
  (setq pbg (polar pmg (* pi (/ 270 180.0)) (/ viewsize 2.0)))
  (setq pmh (polar phg (* pi (/ 0 180.0)) (/ viewsize 2.0)))
  (setq phd (polar pmh (* pi (/ 0 180.0)) (/ viewsize 2.0)))
  (setq pmd (polar phd (* pi (/ 270 180.0)) (/ viewsize 2.0)))
  (setq pbd (polar pmd (* pi (/ 270 180.0)) (/ viewsize 2.0)))
  (setq pmb (polar pbg (* pi (/ 0 180.0)) (/ viewsize 2.0)))
  (setq pmhx (polar pmh (* pi (/ 0 180.0)) (/ viewsize 8.0)))
  (setq pmbx (polar pmb (* pi (/ 180 180.0)) (/ viewsize 8.0)))
  (setq pmgx (polar pmg (* pi (/ 270 180.0)) (/ viewsize 8.0)))
  (setq pmdx (polar pmd (* pi (/ 90 180.0)) (/ viewsize 8.0)))
  (setq pchx (polar pmhx
                    (* pi (/ 270 180.0))
                    (- (/ viewsize 2.0) (/ viewsize 8.0))
             )
  )
  (setq pcbx (polar pmbx
                    (* pi (/ 90 180.0))
                    (- (/ viewsize 2.0) (/ viewsize 8.0))
             )
  )
  (if (eq snap "_ins")
    (progn (grdraw pmhx phg ncolor 0)
           (grdraw pmgx phg ncolor 0)
           (grdraw pmdx pbd ncolor 0)
           (grdraw pmbx pbd ncolor 0)
           (grdraw pmbx pcbx ncolor 0)
           (grdraw pmhx pchx ncolor 0)
           (grdraw pmgx pcbx ncolor 0)
           (grdraw pmdx pchx ncolor 0)
    )
  )
  (if (eq snap "_end")
    (progn (grdraw phg phd ncolor 0)
           (grdraw phg pbg ncolor 0)
           (grdraw pbd phd ncolor 0)
           (grdraw pbd pbg ncolor 0)
    )
  )
  (if (eq snap "_int")
    (progn (grdraw phg pbd ncolor 0) (grdraw phd pbg ncolor 0))
  )
  (if (eq snap "_nea")
    (progn (grdraw phg pbd ncolor 0)
           (grdraw phd pbg ncolor 0)
           (grdraw phg phd ncolor 0)
           (grdraw pbg pbd ncolor 0)
    )
  )
  (if (eq snap "_per")
    (progn (grdraw phg pbg ncolor 0)
           (grdraw pbg pbd ncolor 0)
           (grdraw pmg coord ncolor 0)
           (grdraw coord pmb ncolor 0)
    )
  )
  (if (eq snap "_mid")
    (progn (grdraw pmh pbg ncolor 0)
           (grdraw pbg pbd ncolor 0)
           (grdraw pbd pmh ncolor 0)
    )
  )
  (if (eq snap "_qua")
    (progn (grdraw pmh pmg ncolor 0)
           (grdraw pmg pmb ncolor 0)
           (grdraw pmb pmd ncolor 0)
           (grdraw pmd pmh ncolor 0)
    )
  )
  (if (eq snap "_nod")
    (progn (grdraw phg pbd ncolor 0) (grdraw phd pbg ncolor 0))
  )
  (if (eq snap "_tan")
    (grdraw phg phd ncolor 0)
  )
  (if (or (eq snap "_cen") (eq snap "_nod") (eq snap "_tan"))
    (progn (setq radius (/ viewsize 2.0)
                 strang 0.0
                 endang 360.0
                 percis 10.0
                 pollst nil
           )
           (repeat (fix (/ (- endang strang) percis))
             (setq pollst (append pollst
                                  (list ncolor
                                        (polar coord (* strang (/ pi 180)) radius)
                                        (polar coord (* (+ strang percis) (/ pi 180)) radius)
                                  )
                          )
             )
             (setq strang (+ strang percis))
           )
           (grvecs pollst)
    )
  )
)
					;;
;|					|;









;|					|;
					;;
(defun goto_dbaro_dynamic (/ ucsangle)

(setq ucsangle (angle '(0 0 0) (getvar 'ucsxdir)))
  
  (while (and (setq input (grread t 4 4))
              (or (= (car input) 5)
                  (and (= (car input) 2) (/= (cadr input) 9))
                  (and (= (car input) 2) (= (cadr input) 15))
              )
         )
    (if (= (car input) 5)
      (setq point2 (getsnappoint (cadr input)))
    )
    ;;SET Orthomode if F8 is Pressed  
    (if (and (= (car input) 2) (= (cadr input) 15))
      (if (eq (getvar "ORTHOMODE") 0)
        (setvar "ORTHOMODE" 1)
        (setvar "ORTHOMODE" 0)
      )
    )
    (if (and point1 point2 (eq (getvar "ORTHOMODE") 1))
      (if (<= (abs (- (car point2) (car point1)))
              (abs (- (cadr point2) (cadr point1)))
          )
        (setq point2 (list (car point1) (cadr point2) (caddr point2)))
        (setq point2 (list (car point2) (cadr point1) (caddr point2)))
      )
    )
    ;;SET Orthomode if F8 is Pressed  
    (if point2
      (progn (grdraw point1 point2 141 1)
             (setq lastang (+ ucsangle (angle point1 point2)))
             (if (eq (vla-get-hasattributes vla-blockent) :vlax-true)
               (foreach att (vlax-invoke vla-blockent 'getattributes)
                 (if lastang
                   (progn (vla-put-rotation att ucsangle)
                          (setq nip (polar point1
                                            (+ (angle point1 cip) (angle point1 point2))
                                           cdis
                                    )
                          )
                          (vla-put-insertionpoint
                            vla-blockent
                            (vlax-3d-point (trans nip 1 0))
                          )
                          (vla-put-rotation vla-blockent lastang)
                   )
                 )
               )
             )
      )
    )
  )
)
					;;
;|					|;









;|					|;
					;;
(defun goto_dbaro_specific_angle (/ dbangle ucsangle)
  (setq ucsangle (angle '(0 0 0) (getvar 'ucsxdir)))
  (initget 1)
  (setq dbangle (getreal "\nRotation Angle :"))
  
  (setq lastang (+ ucsangle (* pi (/ dbangle 180.0))))

  (setq point2 (polar point1 lastang 3.0))
  (if point2
    (progn (setq nip (polar point1
                            (+ (angle point1 cip) (angle point1 point2))
                            cdis
                     )
           )
           (vla-put-insertionpoint
             vla-blockent
             (vlax-3d-point (trans nip 1 0))
           )
           (vla-put-rotation vla-blockent lastang)
           (if (eq (vla-get-hasattributes vla-blockent) :vlax-true)
             (foreach att (vlax-invoke vla-blockent 'getattributes)
               (vla-put-rotation att ucsangle)
             )
           )
    )
  )
)
					;;
;|					|;











;|		command DBARO				|;
							;;
(defun c:dbaro (/ input vla-blockent point1 point2 lastang cip nip cdis)

   
  (if (setq vla-blockent (vlax-ename->vla-object (setq bloc (car (entsel)))))
    (progn (setq point1 (getpoint "\nRotation base point.."))
           (setq cip (trans (vlax-safearray->list
                              (vlax-variant-value (vla-get-insertionpoint vla-blockent))
                            )
                            0
                            1
                     )
           )
           (setq cdis (distance point1 cip))
           (initget "D A")
           (setq demand (getkword "\n(D)ynamic Mode\\specific (A)ngle ? <D>: "))
           (if (or (not demand) (= demand "D"))
             (goto_dbaro_dynamic)
             (goto_dbaro_specific_angle)
           )
    )
  )
  (redraw)
)
							;;
;|							;;
	D B A R O (Dynamic Block & Attribute Rotation	;;
	By Andrea Andreetti Copyright  2010		;;
							|;
